c---------------------------------------------------------------------
      subroutine diswav(ich,nrmax,drho1,KTOUT_DW,lparmn,lparmx)
c     calculate distorted waves
c     modified by M. Ichimura 2016.4.22
c---------------------------------------------------------------------
      include 'dimn.fh'
      include 'base.fh'
      include 'dw.fh'
      include 'modpot.fh'
c
      real*4  XX(NRDM),YY(NRDM)
c
      i=ich
      l1min=lparmn+1
      l1max=lparmx+1
      isw  =2*pspn1(i)+0.01
      mxs  =isw+1
c
      do 30 l1=l1min,l1max
        do 20 j=1,mxs
          lc1=l1-1
          fjmin=abs(lc1-pspn1(i))
          fjc1=(j-1)+(lc1-pspn1(i))
          if(fjc1.ge.fjmin) then
C*****************************************************************
C  Calculate distorted waves
             call inte3(1,ich,lc1,drho1,fjc1,XX,YY)
C*****************************************************************
C  NOTE: the point of nsr=1 corresponds to that of nr=2,
C        thus do-loop starts from nr=2
            do 10 nr=2,nrmax,2
              nsr=nr/2
              dwd(nsr,j,l1,i)=cmplx(xx(nr),yy(nr))*bdrc(nr,i)
   10       continue
c*******************************************************************
C  Output distorted waves
C------------------------------------------------------------------
            if(KTOUT_DW.ne.0) then
               nsrmax= nrmax/2
               if(i.eq.1) write(6,525) lc1,fjc1
               if(i.eq.2) write(6,526) lc1,fjc1
c     Print the real part 
               write(6,530)
               write(6,535)(real(dwd(nsr,j,l1,i)),nsr=1,nsrmax)
c     Print the imaginary part
               write(6,555)
               write(6,535) (aimag(dwd(nsr,j,l1,i)),nsr=1,nsrmax)
            end if
c------------------------------------------------------------------
         end if
   20   continue
   30 continue
c
 525  format(/2x,'Incident channel distorted.wave, f  (l=',i3,3x,
     &       'j=',f5.1,')')
 526  format(/2x,'Exit channel distorted.wave, f  (l=',i3,3x,
     &       'j=',f5.1,')')
 530  format(/2x,'real part')
 535  format(5e15.5)
 555  format(/2x,'imag part')
c
      return
      end

