c----------------------------------------------------------------------
      SUBROUTINE GQQ(itrjd,q_int,wgt,tzffr,grpa2,
     &               IRUMAX,NDPMIN,NDPMAX,nsrmax,dsr)
c    calculate the polarization propagator in the momentum space
c    Pi(J,l',s',l,s;q;w) x a constant
C----------------------------------------------------------------------
c   INPUT
c       itrjd : transferred J
c       nsrmax: maxium number of the radial mesh points
c       dsr   : mesh size for the radius
c       kltrmx: maximum number of the index for the transferred l
c       ltr(i): table of transferred l 
c       iparit: transfferd parity specification
c       IRUMAX: Maximum number of correlation index, IRU
c       NDPMIN: minimum number of p(Delta)-h modes specification NDP
c       NDPMAX: maximum number of p(Delta)-h modes specification NDP 
c       kstrmn: maximum number of the transferred s
c       kstrmx: maximum number of the transferred s 
c       istr(i):table of transferred s
c       q_int : intrinsic transferred momentum
c       wgt   : weight for integral over r
c
c       tzffr(IRU,i1,i2,ist1,ist2,NDP1,NDP2):
c        = -(1/pi)*r1^2*Pi(IRU,j,(r1,l1),(r2,l2),w,s1,s2,N/D,N/D)*r2^2
c   OUTPUT
c       grpa2(itrj1,IP,kls,NDM):Polarization propagator(times a factor)  
c           (pi/(4*pi)**2)*Pi(IRU,j,IP,l1,s1,l2,s2,q,w,NDM)
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'fund2.fh'
      include 'grpaj.fh'
C
      real*4  bs(100),bbsl(2,nsrdm)
      real*4  wgt(*)
      complex tzffr(2,nsrdm*2,nsrdm*2,2,2,2,2)
      complex t1, sumr
      data lmax30/30/
      real*8 cpi/3.141592654d0/
c==============================================================
c  Prepare spherical Bessel functions
c-------------------------------------------------------------
      SR=dsr
      do 190 NSR=1,nsrmax 
         CALL SBESSL(q_int*SR,bs,lmax30)
         do 188 kltr=1,kltrmx
            l=ltr(kltr)
            bbsl(kltr,NSR)=bs(L+1)
 188     continue    
            SR=SR+dsr
 190  continue
C==============================================================
c  Calculate ph Green's Functions
c-------------------------------------------------------------
      IP=iparit
      itrj1=itrjd+1
      jtr=itrj1-1
      do 231 NDP1=NDPMIN,NDPMAX
         do 230 NDP2=NDP1,NDPMAX
            if((NDP1.eq.1).and.(NDP2.eq.1)) NDM=1
            if((NDP1.eq.1).and.(NDP2.eq.2)) NDM=2
            if((NDP1.eq.2).and.(NDP2.eq.2)) NDM=3
            do 220 kltr1=1,kltrmx
               l1=ltr(kltr1)
               do 216 kltr2=1,kltrmx
                  l2=ltr(kltr2)
                  do 215 ist1=kstrmn,kstrmx
                     s1=istr(ist1)
                     do 213 ist2=kstrmn,kstrmx
                        s2=istr(ist2)
                        kls=(2-ip)*(s1*2+s2+1)+(ip-1)*(l1-jtr+1
     &                       +(l2-jtr+1)/2+1)
c
                        sumr=0.0
                        do 212 nr2=1,nsrmax
                           t1=0.0
                           i2=nr2+(kltr2-1)*nsrmax
                           do 210 nr1=1,nsrmax
                              i1=nr1+(kltr1-1)*nsrmax
                              t1=t1+bbsl(kltr1,nr1)*wgt(nr1)
     1                        *tzffr(IRUMAX,i1,i2,ist1,ist2,NDP1,NDP2)
 210  continue
      sumr=sumr+bbsl(kltr2,nr2)*t1*wgt(nr2)
 212  continue
      grpa2(itrj1,IP,kls,NDM)=-CPI*CPI*sumr
 213  continue
 215  continue
 216  continue
 220  continue
 230  continue
 231  continue
c
      return
      end
