c----------------------------------------------------------------------
      SUBROUTINE WXRPROP(nan,NDMT,nwmax,omegld,KTRPA,respT,respL)
c---------------------------------------------------------------------
C     Proportionality check
C     write ID0/RS, IDn/RT, IDq/RL, IDp/RT
c     Programmed by M.Ichimura 2017.10.5
c----------------------------------------------------------------------
C  INPUT
c     KTRPA    : Correlation type
c     NDMT     : =1 for no Delta,  =4 for with Delta
c     nan      : Angle number
c     nwmax    : number of transferred energies
c     omegld(nw): Table of transffered energies in lab. 
c     rps(nw)  : spin scalar response function at the given q(nan)
c     respT(nw): spin longitudinal response function at the given q(nan)
c     respL(nw): spin transverse response function at the given q(nan)
c     xid0l(nan,nw,NDMT):ID0(theta, omega) 
c     xidnl(nan,nw,NDMT):IDn(theta, omega)
c     xidql(nan,nw,NDMT):IDq(theta, omega)
c     xidpl(nan,nw,NDMT):IDp(theta, omega)
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'rsrtrl.fh'
      include 'xsec.fh'
      real*4 omegld(*)
      real*4 respT(nwdm), respL(nwdm)
c======================================================================
      write(6,5000)
 5000 format(
     &/'==========================================================='
     &/'PROPORTIONALITY CHECK'
     &/'-----------------------------------------------------------')
      if(KTRPA.eq.0) write(6,*) '  Uncorrelated'
      if(KTRPA.eq.1) write(6,*) '  TDA'
      if(KTRPA.eq.2) write(6,*) '  RPA'
      if(KTRPA.eq.3) write(6,*) '  RPA for N TDA for D'
C
C    OUTPUT ID0/RS, IDn/RT, IDq/RL, IDp/RT
            write(6,2004) 
            do nw=1,nwmax
               write(6,2100) omegld(nw),
     1          xid0l(nan,nw,NDMT)/rps(nw),
     2          xidnl(nan,nw,NDMT)/respT(nw),
     3          xidql(nan,nw,NDMT)/respL(nw),
     4          xidpl(nan,nw,NDMT)/respT(nw)
            end do
            write(*,*)
C   
 2100 format(5x,f6.2,4e13.5)
 2004 format(5x,
     1 'omega(MeV) ID0/RS      IDn/RT       IDq/RL,     IDp/RT')
C
      return
      end
